<%@ page language="java" contentType="text/html;charset=UTF-8"%>
<%@ page import="com.bea.netuix.nf.container.jsp.JspContext,
                 com.bea.netuix.nf.container.jsp.tags.JspUIControlFactory,
                 com.bea.netuix.servlets.manager.SingleFileProcessor,
                 java.net.URL,
                 java.net.URLConnection,
                 java.net.HttpURLConnection,
                 com.bea.netuix.nf.container.jsp.tags.ReflectionMetaControlFactory,
                 com.vladium.utils.ObjectProfiler,
                 com.vladium.utils.IObjectProfileNode,
                 java.io.BufferedReader,
                 java.io.InputStreamReader,
                 java.util.Map,
                 java.util.Iterator,
                 java.util.Set,
                 java.util.TreeSet"%>

<%!
    Set filenames = new TreeSet();

    public void jspInit()
    {
        Set files = this.getServletConfig().getServletContext().getResourcePaths("/");

        if (files != null)
        {
            Iterator iterator = files.iterator();

            while (iterator.hasNext())
            {
                String file = (String) iterator.next();

                if (file.endsWith(".portal"))
                {
                    filenames.add(file.substring(file.indexOf("/") + 1));
                }
            }
        }
    }
%>

<jsp:useBean id="portalInfoBean" class="com.bea.netuix.util.PortalInfoBean" scope="request">
    <jsp:setProperty name="portalInfoBean" property="*"/>
</jsp:useBean>

<html>
<head>
  <meta http-equiv="content-type"
 content="text/html; charset=ISO-8859-1">
  <title>Portal Sizing Helper</title>
  <meta name="author" content="BEA Systems">
</head>
<body>
<h3>Introduction</h3>
<p>
This jsp takes a .portal file and computes memory required by object models.
There are two object models for a portal, 1) run-time representation to process a request
(Presentation Control Tree) and 2) in-memory representation (MetaUIControl Tree) used for creating
presentation control tree for every request. The MetaUIControl tree will be cached for every user,
if they have customized their portals.
<p>
<br>
<h3>Statistics Computed</h3>
<ul>
  <li>MetaUIControl Tree memory size in bytes</li>
  <li>Presentation Control Tree memor size in bytes</li>
  <li>Response Size in bytes</li>
  <li>Presentation Control Tree statistics</li>
</ul>
<h3>Memory Requirements For a Portal</h3>
The memory usage depends entirely on portal application, number of
users to support, etc, however following equation could help in
finding out approximate memory size.<br>
<br>
<pre>
Memory needed = MetaUIControlTree size *
                ((number of users with customizations) + (number of locales supported)) +
                Presentation Control Tree size *
                (Maximum number of users using portal application at any point of time) +
                &lt;memory for other functionalities&gt;
</pre>
<br>
<h3>Note:</h3>
The memory size is calculated using sizeOf package from
www.javaworld.com. Please refer to <a
 href="http://www.javaworld.com/javaworld/javaqa/2003-12/02-qa-1226-sizeof.html?">the java sizeOf
article</a> for more information on how the memory size is computed.<br>
<br>
<hr style="width: 100%; height: 2px;">
<h3 style="text-align: center;">Portal Statistics</h3>
<br>
<br>
<h4 style="text-align:center;">The .portal files present in this web app are listed below, please select a portal file from this list.</h4>
<p align="center">
        <form method="post" action="portal_size.jsp">
            <table border="0">
                <tr>
                    <td style="color:#ff0033;">Portal FileName*</td>
                    <td>
<%
                        if (filenames.isEmpty())
                        {
%>
                            NO .PORTAL FILES FOUND IN THIS WEBAPP.
<%
                        }
                        else
                        {
%>
                        <select name="portalFilename" size="4">
<%
                            Iterator iterator = filenames.iterator();

                            while (iterator.hasNext())
                            {
                                String filename = (String) iterator.next();
%>
                                <option><%=filename%></option>
<%
                            }
                        }
%>
                        </select>
                    </td>
                </tr>
                <tr valign="middle" align="center">
                    <td></td>
                    <td align="center"><input value="Show-Statistics" type="submit"/></td>
                </tr>
            </table>
        </form>
<%
    if (request.getMethod().equals("POST"))
    {
        String hostName = request.getServerName();

        int port = request.getServerPort();

        String contextPath = request.getContextPath();

        URL url = new URL("http", hostName, port, contextPath+"/"+portalInfoBean.getPortalFilename());
%>
        <jsp:setProperty name="portalInfoBean" property="completeURL" value="<%=url.toString()%>"  />
<%
        if (portalInfoBean.validate())
        {
            portalInfoBean.computeStatistics();

%>
            <table border="1">
                <th align="center" colspan="2">Portal Object Model Statistics for <%=portalInfoBean.getPortalFilename()%></th>
                <tr>
                    <td>MetaUIControl Tree size</td>
                    <td align="center"><%=portalInfoBean.getMetaUIControlTreeSize()%> bytes</td>
                </tr>
                <tr>
                    <td>Presentation Control Tree size</td>
                    <td align="center"><%=portalInfoBean.getUiControlTreeSize()%> bytes</td>
                </tr>
                <tr>
                    <td>Response size</td>
                    <td align="center"><%=portalInfoBean.getResponseSize()%> bytes</td>
                </tr>
            </table>
<%
            Map stats = portalInfoBean.getUiControlTreeStatistics();
            Iterator iterator = stats.entrySet().iterator();
%>
<br>
            <table border="1">
                <th align="center" colspan="2">Presentation Control Tree Statistics for <%=portalInfoBean.getPortalFilename()%></th>
                <tr>
                    <th align="center">PresentationControlName</th>
                    <th align="center">Count</th>
                </tr>
<%
            int total = 0;
            while (iterator.hasNext())
            {
                Map.Entry entry = (Map.Entry) iterator.next();

                Object name = entry.getKey();

                int value = ((Integer)entry.getValue()).intValue();

                total = total + value;
%>
                <tr>
                    <td><%=name%></td>
                    <td align="center"><%=value%></td>
                </tr>
<%
            }
%>
                <tr>
                    <td>Total</td>
                    <td align="center"><%=total%></td>
                </tr>

            </table>
<%

        }
    }
%>
</p>
<br>
<hr style="width: 100%; height: 2px;">
</body>
</html>

